<template>
<div class="col s12 m6">
        <div>
          <div class="page-subtitle">
            <h4>Редактировать</h4>
          </div>

          <form @submit.prevent="submitHandler">
            <div class="input-field" >
              <select ref="select" v-model="current"  >
                <option v-for="c in categories" :key="c.id" :value="c.id">
                  {{c.title}}</option>
              </select>
              <label>Выберите категорию</label>
            </div>

           <div class="input-field">
              <input v-model="title"
                  id="name"
                  type="text"
                  :class="{invalid: v$.title.$dirty && !v$.title.required }"
              >
              <label for="name">Название</label>
 <small class="helper-text invalid" v-for="(error, index) of v$.title.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>

              <!-- <span v-if="v$.title.$dirty && !v$.title.required" class="helper-text invalid">Введите название</span> -->
            </div>

            <div class="input-field">
              <input v-model.number="limit"
                  id="limit"
                  type="number"
                  :class="{invalid: v$.limit.$dirty && !v$.limit.minValue }"
              >
              <label for="limit">Лимит</label>
               <small class="helper-text invalid" v-for="(error, index) of v$.limit.$errors" :key="index">
              {{ error.$property }} {{error.$message}}
            </small>
              <!-- <span v-if="v$.limit.$dirty && !v$.limit.minValue" class="helper-text invalid">Минимальная величина</span> -->
            </div>

            <button class="btn waves-effect waves-light" type="submit">
              Обновить
              <i class="material-icons right">send</i>
            </button>
          </form>
        </div>
      </div>
</template>

<script>
import { useVuelidate } from "@vuelidate/core";
import { required, minValue } from "@vuelidate/validators";

export default {
  setup() {
    return { v$: useVuelidate() };
  },
  created() {
    const {id, limit, title} =  this.categories[0];
    this.current= id;
    this.title= title;
    this.limit= limit;
  },
  data:()=>({
        title:'',
        limit:1,
        select: null,
        current: null,
  }),
  mounted(){
    M.updateTextFields();
    this.select=M.FormSelect.init(this.$refs.select);
  },
  validations() {
    return {
      title: { required },
      limit: { required, minValue: minValue(1) }
    };
  },
  watch:{ 
    current(catId){
      const {id, limit, title}=this.categories.find(c=>c.id==catId);
      this.title= title;
      this.limit= limit;
      // console.log(value);
    }

  },
  props:{ 
    categories:{
      type:Array,
      required:true,
      // default:[],
    }
  },
  beforeUnmount() {
    if (this.select && this.select.destroy) {
      this.select.destroy();
    }
  },
  methods: {
    async submitHandler() {
      this.v$.$touch();
      if (this.v$.$error) return;

      const formdata = {
        title: this.title,
        limit: this.limit,
        id: this.current
      };

      try{ 
        const new_category= await this.$store.dispatch('updateCategory',formdata);
        this.$message('Category is successfully updated');
        this.$emit('updated',formdata);
        console.log(new_category);
      }catch(e){
        console.log({e});
         this.$error(e.code);
        // this.$error(messages[this.$route.query.message] || "Nima xato ketganini tushunmadim")
      }
      
    }
  }

}
</script>